/*
 * Copyright (c) 2000 living systems(R) AG, Germany. All rights reserved.
 * Author: Klaus Dorer
 *
 */

package com.ls.research.robocup;

/**
 * This interface contains all global constants
 *
 * @author  Klaus Dorer
 */
import com.ls.research.robocup.perception.ObjectInfo;

public interface RobocupConstants
{
	int	   SERVER_VERSION_USED		=	7;

	String VIEWMODE_NARROW			= 	"narrow";
	String VIEWMODE_NORMAL			= 	"normal";
	String VIEWMODE_WIDE			= 	"wide";

	String VIEWQUALITY_LOW			= 	"low";
	String VIEWMODE_HIGH			= 	"high";

	double D_ZERO_P					=	0.000001;
	double D_ZERO_N					= 	-0.000001;

	int	NOT_EXISTING				= 	ObjectInfo.NOT_EXISTING;

	final int TYPE_BALL_POSITION	=	11;
	final int TYPE_AGENT_POSITION	=	12;
	final int TYPE_NO_MORE_DATA		=	13;
	final int TYPE_PLAYER_POSITION	=	14;
	final int TYPE_DEBUG_MSG		=	100;
	// 100 - 110 are reserved for different debug levels

	final int DEBUG_LEVEL_0			=	0;
	final int DEBUG_LEVEL_1			=	1;
	final int DEBUG_LEVEL_2			=	2;
	final int DEBUG_LEVEL_3			=	3;
	final int DEBUG_LEVEL_4			=	4;
	final int DEBUG_LEVEL_5			=	5;
	final int DEBUG_LEVEL_6			=	6;
	final int DEBUG_LEVEL_MAX		=	7;

	final int MAX_DEBUG_LEVEL		=	7;



	final int DEBUG_HIGHACTION		=	DEBUG_LEVEL_0;
	final int DEBUG_MIDACTION		=	DEBUG_LEVEL_1;
	final int DEBUG_LOWACTION		=	DEBUG_LEVEL_2;
	final int DEBUG_ACTION			=	DEBUG_LEVEL_3;

	final int DEBUG_HIGHPERCEPTION	=	DEBUG_LEVEL_0;
	final int DEBUG_MIDPERCEPTION	=	DEBUG_LEVEL_1;
	final int DEBUG_LOWPERCEPTION	=	DEBUG_LEVEL_2;
	final int DEBUG_PERCEPTION		=	DEBUG_LEVEL_3;

	final int CATEGORY_ACTION		=	0;
	final int CATEGORY_PERCEPTION	=	1;
	final int CATEGORY_MAX			=	2;
}
