/****************************************************************************
 *	This is the class representing all sense_body information
 *	Members are public since this are only data containers
 ***************************************************************************/
package com.ls.research.robocup.perception;

import com.ls.research.robocup.RobocupConstants;

import java.util.StringTokenizer;

public class PropriozeptiveInfo
{
	public	int				m_time;
	public	String			m_viewMode;
	public	String			m_viewQuality;
	public	int				m_stamina;
	public	float			m_effort;
	public	float			m_absSpeed;
	public	int			    m_speedAngle;
	public	int				m_headAngle;
	public	int				m_kickCount;
	public	int				m_dashCount;
	public	int				m_turnCount;
	public	int				m_sayCount;
	public	int				m_turnNeckCount;

	// server 7
	public	int				m_catchCount;
	public	int				m_moveCount;
	public	int				m_changeViewCount;

	/**
	 * Parses the sense body string into java objects
	 */
	public void parse(String message)
	{
		StringTokenizer	tokenizer	= null;
		String 			token 		= null;

		try
		{
			message.trim();
			tokenizer = new StringTokenizer(message,"() ");

			// (sense_body 0
			tokenizer.nextToken();
			m_time = Integer.parseInt( tokenizer.nextToken() );

			// (view_mode high normal)
			tokenizer.nextToken();
			m_viewQuality = tokenizer.nextToken();
			m_viewMode = tokenizer.nextToken();

			// (stamina 2000 1)
			tokenizer.nextToken();
			m_stamina = (int) Float.parseFloat( tokenizer.nextToken() );
			m_effort = Float.parseFloat( tokenizer.nextToken() );

			// (speed 0) ab version 7 (speed 0 0)
			tokenizer.nextToken();
			m_absSpeed = Float.parseFloat( tokenizer.nextToken() );
			if (RobocupConstants.SERVER_VERSION_USED >= 7)
				m_speedAngle = Integer.parseInt( tokenizer.nextToken() );

			// (head_angle 0)
			tokenizer.nextToken();
			m_headAngle = Integer.parseInt( tokenizer.nextToken() );

			// (kick 0)
			tokenizer.nextToken();
			m_kickCount = Integer.parseInt( tokenizer.nextToken() );

			// (dash 0)
			tokenizer.nextToken();
			m_dashCount = Integer.parseInt( tokenizer.nextToken() );

			// (turn 0)
			tokenizer.nextToken();
			m_turnCount = Integer.parseInt( tokenizer.nextToken() );

			// (say 0)
			tokenizer.nextToken();
			m_sayCount = Integer.parseInt( tokenizer.nextToken() );

			// (turn_neck 0)
			tokenizer.nextToken();
			m_turnNeckCount = Integer.parseInt( tokenizer.nextToken() );

			if (RobocupConstants.SERVER_VERSION_USED >= 7)
			{
				// (catch 0)
				tokenizer.nextToken();
				m_catchCount = Integer.parseInt( tokenizer.nextToken() );

				// (move 0)
				tokenizer.nextToken();
				m_moveCount = Integer.parseInt( tokenizer.nextToken() );

				// (changeView 0)
				tokenizer.nextToken();
				m_changeViewCount = Integer.parseInt( tokenizer.nextToken() );
			}

		} catch(Exception e) {
			System.out.println("Error parsing sense body information");
			System.out.println(e);
			while( tokenizer.hasMoreTokens() )
				System.out.print(tokenizer.nextToken());

			System.out.println("Message: " + message);
		}
	}
}