//***************************************************************************
//
//	This interface declares functions which are used to send
//	command to player
//
//***************************************************************************

package com.ls.research.robocup.server;

public interface SoccerActionInterface
{
	String ACTION_MOVE			= "move";
	String ACTION_TURN			= "turn";
	String ACTION_TURN_NECK		= "turn_neck";
	String ACTION_DASH			= "dash";
	String ACTION_KICK			= "kick";
	String ACTION_CATCH_BALL	= "catch_ball";
	String ACTION_SAY			= "say";
	String ACTION_CHANGE_VIEW	= "change_view";
	String ACTION_SENSE_BODY	= "sense_body";
	String ACTION_CONNECT		= "init";
	String ACTION_RECONNECT		= "reconnect";
	String ACTION_DISCONNECT	= "bye";
	String ACTION_SCORE			= "score";

	String CONNECT_GOALIE		= "goalie";

	String VIEWMODE_NARROW		= "narrow";
	String VIEWMODE_NORMAL		= "normal";
	String VIEWMODE_WIDE		= "wide";
	
	String VIEWQUALITY_LOW		= "low";
	String VIEWMODE_HIGH		= "high";

	// This function sends move command to the server
	void move(int x, int y);

	// This function sends turn command to the server
	void turn(int moment);

	// This function sends turn_neck command to the server
	void turnNeck(int angle);

	// This function sends dash command to the server
	void dash(int power);

	// This function sends kick command to the server
	void kick(int power, int direction);

	// This function sends catch command to the server
	void catchBall(int direction);

	// This function sends say command to the server
	void say(String message);
	
	// This function sends change_view command to the server
	void changeView(String angle, String quality);
	
	// This function sends change_view command to the server
	void senseBody();
	
	// This function sends score command to the server to ask for the current score
	void score();
		
	// connect to server
	void connectToServer(String team, String version, boolean goalie);

	// reconnect to server
	void reConnectToServer(String team, int number);
	
	// disconnect from server
	void disconnectFromServer();
}

